public class MyThread extends Thread {
  
  float x0,y0,x1,y1;
  color farbe;
  PGraphics pg;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(float px0, float py0, float px1, float py1, color pfarbe) {
    // der Ausschnitt, den der Thread malen soll, wird als 
    // Parameter übergeben
    x0=px0; y0=py0; 
    x1=px1; y1=py1;
    farbe = pfarbe;
    pg = createGraphics(200,200);
    pg.beginDraw();
      pg.background(255);
      pg.noStroke();    
    pg.endDraw();
  }

  //-----------------------------------------
  // je nach Betrag von x und y werden auf der 
  // PGraphics-Leinwand rote (außen) oder 
  // zufallsfarbene kleine Kreise ausgegeben
  //-----------------------------------------
  
  public void run() {
    for (int i=0; i<10000; i++) {
      float x = random(x0,x1);
      float y = random(y0,y1);
      int px = (int)(pg.width*(x-x0)/(x1-x0));
      int py = (int)(pg.height*(y-y0)/(y1-y0));
      pg.beginDraw();
        // liegt der Punkt ausserhalb des Kreises, male rot
        // ansonsten blau
        if (abs(x)<0.75 && abs(y)<0.75) pg.fill(farbe);
                              else pg.fill(255,0,0);
         pg.ellipse(px,py,3,3);
      pg.endDraw();
      // warte ein wenig, damit man das Zeichnen wirklich sieht
      delay(30); 
    }
  }
}

/////////////////////////////////////////////////////////////////
//
// Jetzt das Hauptprogramm
//
/////////////////////////////////////////////////////////////////

ArrayList<MyThread> threads;

void setup() {
  background(255);
  
  threads = new  ArrayList<MyThread>();
  
  size(440, 440);
  
  // starte vier Threads, die jeweils einen Teil der Quadratfläche
  // über die roten und Zufallsfarbe- Punkte darstellen sollen.
  for (float y=-1; y<1; y++) {
   for (float x=-1; x<1; x++) {
      MyThread t = new MyThread(x,y,x+1,y+1,color(random(100),random(255),random(255)));
      threads.add(t);
      t.start();
   }
  }
}

/////////////////////////////////////////////////////////////////

void draw() {
  
  // die Draw-Methode fügt die PGraphics-Zeichenflächen
  // der Threads zu einem Bild zusammen
  for (int i=0; i<threads.size(); i++)
     image(threads.get(i).pg,(i%2)*200+20,(i/2)*200+20);
}

/////////////////////////////////////////////////////////////////

void keyPressed() {
  save("tmp.png");
}

/////////////////////////////////////////////////////////////////